/* 
 * File:   BuildEstimator.h
 * Author: chris
 *
 * Created on April 21, 2014, 4:35 PM
 */

#ifndef BUILDESTIMATOR_H
#define	BUILDESTIMATOR_H

#include "PlayerBuildState.h"

using namespace std;

enum QueueResult{Success,Stall,Deadlock, QUEUE_RESULT_TYPES};

class BuildEstimator
{
public:

    BuildEstimator() :  NextUnitId(0), NextPlayerId(0),
    currentTimeInFrames(0), playerStates(map<int, PlayerBuildState>())
    {

    }
    BuildEstimator(const BuildEstimator& orig) : 
     NextUnitId(orig.NextUnitId), NextPlayerId(orig.NextPlayerId),currentTimeInFrames(orig.currentTimeInFrames),
     playerStates(orig.playerStates)
    {
    };
    virtual ~BuildEstimator();
    const int AddNewPlayer(); //returns new players ID;
    const int GetPlayerCount() const;
    const QueueResult QueueCommand(const int& playerId, const BWAPI::UnitType& type, const int& unitTask = 0);
    const bool IncreaseCurrentFrame(const int& frameCount = 1);
    const int GetCurrentFrame();
    const list<UnitCommandQueued>& GetCompleteCommands(const int& player);
    const int GetCompletedUnitCount(const int& player, const BWAPI::UnitType& type);
    //const bool CreateStartingUnits(const UnitCommandRequest& command);
private:
    int NextUnitId;
    int NextPlayerId;
    int currentTimeInFrames;

    map<int, PlayerBuildState> playerStates;
    
    UnitCommandRequest MakeNewCommandRequest(const BWAPI::UnitType& type, const int& unitTask = 0);
};

#endif	/* BUILDESTIMATOR_H */

